StartupEvents.registry('palladium:abilities', (event) => {
  event.create('alienevo:xp_system')
  .icon(palladium.createItemIcon('palladium:vibranium_circuit'))
    .addProperty("Alien.Level", "string", "Alien.Level", "Scoreboard name for alien level")
    .addProperty("Alien.XP", "string", "Alien.XP", "Scoreboard name for alien XP")
    .addProperty("Alien.SkillPoint", "string", "Alien.SkillPoint", "Scoreboard name for alien skill points")
    
    .firstTick((entity, entry, holder, enabled) => {
      if (enabled && entity.isPlayer()) {
        const levelScoreName = entry.getPropertyByName("Alien.Level");
        const xpScoreName = entry.getPropertyByName("Alien.XP");
        const skillPointScoreName = entry.getPropertyByName("Alien.SkillPoint");
        
        let scoreboard = Utils.server.scoreboard;
        
        if (!scoreboard.hasObjective(levelScoreName)) {
          scoreboard.addObjective(levelScoreName, 'dummy');
        }
        
        if (!scoreboard.hasObjective(xpScoreName)) {
          scoreboard.addObjective(xpScoreName, 'dummy');
        }
        
        if (!scoreboard.hasObjective(skillPointScoreName)) {
          scoreboard.addObjective(skillPointScoreName, 'dummy');
        }
        
        const username = entity.getGameProfile().getName();
        
        const levelObj = scoreboard.getObjective(levelScoreName);
        const xpObj = scoreboard.getObjective(xpScoreName);
        const skillPointObj = scoreboard.getObjective(skillPointScoreName);
        
        if (levelObj && xpObj && skillPointObj) {
          scoreboard.getOrCreatePlayerScore(username, levelObj);
          scoreboard.getOrCreatePlayerScore(username, xpObj);
          scoreboard.getOrCreatePlayerScore(username, skillPointObj);
        }
      }
    });
});