StartupEvents.registry('palladium:abilities', (event) => {
    const OMNITRIX_PROPERTY_KEY = 'omnitrix_cycle';
    const CURRENT_PLAYLIST_KEY = 'current_playlist';
    const CURRENT_ALIEN_SLOT_KEY = 'current_alien_slot';

    const DEFAULT_PLAYLIST = 1;
    const DEFAULT_SLOT = 1;
    const MAX_PLAYLISTS = 100;
    const MAX_SLOTS = 10;

    event.create('alienevo:omnitrix_cycle_playlists')
        .icon(palladium.createItemIcon('minecraft:blaze_rod'))
        .addProperty("cycle_direction", "string", "right", "Direction to cycle playlists")
        .addProperty("property", "string", OMNITRIX_PROPERTY_KEY, "Cycle property")
        .tick((entity, entry, holder, enabled) => {
            if (enabled) {
                const direction = entry.getPropertyByName('cycle_direction') === "right" ? 1 : -1;
                let currentPlaylist = entity.persistentData[CURRENT_PLAYLIST_KEY] || DEFAULT_PLAYLIST;
                let currentSlot = entity.persistentData[CURRENT_ALIEN_SLOT_KEY] || DEFAULT_SLOT;
                let startingPlaylist = currentPlaylist;
                let alienFound = false;
                
                do {
                    currentPlaylist += direction;
                    
                    if (currentPlaylist > MAX_PLAYLISTS) currentPlaylist = 1;
                    if (currentPlaylist < 1) currentPlaylist = MAX_PLAYLISTS;
                    
                    for (let slot = 1; slot <= MAX_SLOTS; slot++) {
                        let alienNumber = entity.persistentData[`alienevo.alien_${currentPlaylist}_${slot}`];
                        
                        if (alienNumber > 0) {
                            
                            entity.persistentData[CURRENT_PLAYLIST_KEY] = currentPlaylist;
                            entity.persistentData[CURRENT_ALIEN_SLOT_KEY] = slot;
                            
                            const propertyKey = entry.getPropertyByName('property');
                            palladium.setProperty(entity, propertyKey, alienNumber);
                            
                            alienFound = true;
                            break;
                        }
                    }
                    
                    if (alienFound) break;
                    
                } while (currentPlaylist !== startingPlaylist);
            }
        });
});