EntityEvents.hurt((event) => {
    if (event.source && event.source.player) {
        let player = event.source.player;
        if (abilityUtil.hasPower(player, "alienevo_aliens:kineceleran") &&
            abilityUtil.isEnabled(event.source.player, "alienevo_aliens:kineceleran", "punch_barrage")) {
            let entity = event.entity;
            entity.addTag('noInvulnerable');
            entity.invulnerableTime = 0;
        }
    }
});

ServerEvents.tick((event) => {
    if (event.server.players.length > 0) {
        for (let entity of event.server.entities) {
            if (entity.getTags().contains('noInvulnerable')) {
                entity.invulnerableTime = 20;
                entity.removeTag('noInvulnerable');
            }
        }
    }
});

EntityEvents.hurt(event => {
    let entity = event.entity;
    if (entity.type == 'minecraft:player' && 
        abilityUtil.hasPower(entity, "alienevo_aliens:petrosapien") && 
        abilityUtil.isEnabled(entity, "alienevo_aliens:petrosapien", "shield_activate")) {
        let player = entity;
        let rayTrace = player.rayTrace(6);
        if (rayTrace && rayTrace.entity && rayTrace.entity == event.source.actual) {
            event.level.playSound(null, entity.x, entity.y, entity.z, "minecraft:block.amethyst_block.break", "ambient", 2, 1);
            entity.invulnerableTime = 20;
            event.source.actual.invulnerableTime = 0;
        }
        if (!rayTrace || !rayTrace.entity || rayTrace.entity != event.source.actual) {
            entity.invulnerableTime = 0;
        }
    }
});

EntityEvents.hurt(event => {
    if (event.source && event.source.player && 
        abilityUtil.hasPower(event.source.player, "alienevo_aliens:petrosapien") && 
        abilityUtil.isEnabled(event.source.player, "alienevo_aliens:petrosapien", "battle_mode") &&
        !abilityUtil.isEnabled(event.source.player, "alienevo_aliens:petrosapien", "shield_activate")) {
        let level = event.level;
        let entity = event.entity;
        level.playSound(null, entity.x, entity.y, entity.z, "minecraft:entity.player.attack.sweep", "ambient", 2, 1);
        entity.level.spawnParticles('minecraft:sweep_attack', true, entity.x, entity.y + 1.7, entity.z, 0, 0, 0, 1, 0);
    }
});


